function Y = polynom_regress(p,X,A);
//-----------------------------------------------------------------------  
// function Y = polynom_regress(p,X,A);
//
// perform polynomial (vectorial) regression 
// Y = transpose(A)*monomvec(p,X) of scalar or vectorial functions.
//
// input:    p            desired polynomial degree of regression (also 
//                        implicitly contained in matrix A)
//           X            matrix of columnwise points in which the 
//                        regression function will be evaluated.
//           A            Regression matrix obtained e.g. from 
//                        regress_matrix.
//
// output:   Y            matrix with columnwise results from the 
//                        regression function evaluated in the columns 
//                        of X
//
//-----------------------------------------------------------------------  
//   $RCSfile: polynom_regress.sci,v $
//  $Revision: 1.1 $
//      $Date: 2002/09/10 15:15:36 $
//  Copyright: IIF-LMB $Author: poluru $
//
//-----------------------------------------------------------------------
//  $Log: polynom_regress.sci,v $
//  Revision 1.1  2002/09/10 15:15:36  poluru
//  "macros" directory structure is created
//
//-----------------------------------------------------------------------

  Y = A'*monomvec(p,X);
  clear X p
endfunction;

