function polclass_demo( varargin )
//-----------------------------------------------------------------------  
//function polclass_demo( varargin )
//
//This function describes how the functions computeFc()and
//Fsynthesis() work for a given polygon
// input:  varargin        variable no. of arguments ( i.e. either
//                         no args. or sholud be as follows)
//        'pfeatures'      if this argn. is there the feature-vector.
//                         will be displayed on clicking classify button
//        'setpolygon'     if this argn. is there the next argn.
//                         should be a polygon of size: 2*n
//        "high_index"     to set the index of high frequency FC.s, this
//                         argn should be followed by an integer
//        "low_index"      to set the index of low frequency FC.s, this
//                         argn should be followed by an integer
//
// output: res             (description of argument, type, optional?)
//
//-----------------------------------------------------------------------  
//   $RCSfile: polclass_demo.sci,v $
//  $Revision: 1.1 $
//      $Date: 2002/09/10 15:15:36 $
//  Copyright: IIF-LMB $Author: poluru $
//
//-----------------------------------------------------------------------
//  $Log: polclass_demo.sci,v $
//  Revision 1.1  2002/09/10 15:15:36  poluru
//  "macros" directory structure is created
//
//-----------------------------------------------------------------------


// creating a figure
  f =figure('position', [20,200 350 350],'tag','polclass_demo_objfig');   
  
  t1 = uicontrol(f,'style','text','position',[75 310 200 25], ...
		 'fontsize',15, 'fontweight',"bold",'string', ...
		 "Polygon Classification Demo");
  t2 = uicontrol(f,'style','text','position',[30 275 112 25], ...
		 'fontsize',12,'fontweight',"bold",'string', "Feature"+...
		 " Selection : ");
    
  // Names Of the features As text fields
  ht1 = uicontrol(f,'style','text','position',[30 240 53 25], ...
		  'String',"Boundary");
  ht2 = uicontrol(f,'style','text','position',[30 210 25 25],'String', ...
		  "Area");
  ht3 = uicontrol(f,'style','text','position',[30 180 72 25], ...
		  'String',"Compactness");
  ht4 = uicontrol(f,'style','text','position',[200 240 80 25],'String', ...
		  "Low freq. FC");
  ht5 = uicontrol(f,'style','text','position',[200 210 85 25], ...
		  'String',"High freq. FC");
  ht6 = uicontrol(f,'style','text','position',[200 180 80 25],'String', ...
		  "Low freq. Fd");
  ht7 = uicontrol(f,'style','text','position',[200 150 85 25], ...
		  'String',"High freq. Fd");
  
  // check boxes for changing the values of individual Fourier coef.s 
  rb1 = uicontrol(f,'style','checkbox','position',[120 240 25 ...
		    25],'Min',0,'Max',1,'tag','sci_pd_1'); 
  rb2 = uicontrol(f,'style','checkbox','position',[120 210 25 ...
		    25],'Min',0,'Max',1,'tag','sci_pd_2');
  rb3 = uicontrol(f,'style','checkbox','position',[120 180 25 ...
		    25],'Min',0,'Max',1,'tag','sci_pd_3');  
  rb4 = uicontrol(f,'style','checkbox','position',[295 240 25 ...
		    25],'Min',0,'Max',1,'tag','sci_pd_4');
  rb5 = uicontrol(f,'style','checkbox','position',[295 210 25 ...
		    25],'Min',0,'Max',1,'tag','sci_pd_5');
  rb6 = uicontrol(f,'style','checkbox','position',[295 180 25 ...
		    25],'Min',0,'Max',1,'tag','sci_pd_6');
  rb7 = uicontrol(f,'style','checkbox','position',[295 150 25 ...
		    25],'Min',0,'Max',1,'tag','sci_pd_7');
  //setting all the feature values to zero
  set(rb1,'value',0);  set(rb2,'value',0);  set(rb3,'value',0);
  set(rb4,'value',0);  set(rb5,'value',0);  set(rb6,'value',1);
  set(rb7,'value',1);
  
  // push buttons to activate the edit fields
  pu1 = uicontrol(f,'style','pushbutton','position',[30 91 97 25], ...
		  'String'," new Polygon"); 
  pu2 = uicontrol(f,'style','pushbutton','position',[208 91 100 25], ...
		  'String'," Classify Polygon");
  pu3 = uicontrol(f,'style','pushbutton','position',[30 41 50 25], ...
		  'String',"  HELP ");
  pu4 = uicontrol(f,'style','pushbutton','position',[208 41 50 25], ...
		  'String',"  EXIT");
  
  // call backs for the sliders and push buttons
  set(pu1,'callback',"polclass_demo_call_back(''newpol'')");
  set(pu2,'callback',"polclass_demo_call_back(''classify'')");
  set(pu3,'callback',"polclass_demo_call_back(''help'')");
  set(pu4,'callback',"polclass_demo_call_back(''exit'')");
  
  // selection of polygons from varargin
  Lpoly=list(); i=1;j=1;hfc= 20;lfc=5;
  recall="no"; printfv="no"; Max=[];Min=[];
  while i<= length(varargin),
    if varargin(i)== "setpoly", 
      pol=varargin(i+1);
      Lpoly(j)=pol;
      Max=[Max,[max(pol(1,:));max(pol(2,:))] ];
      Min=[Min,[min(pol(1,:));min(pol(2,:))] ];
      i=i+2;j=j+1;
    else 
      if varargin(i)== "high_index",
	hfc=varargin(i+1);
	i=i+2;
      else
	if varargin(i)== "low_index",
	  lfc=varargin(i+1);
	  i=i+2;
	else 
	  if varargin(i)== "patrec_demos",
	    recall="yes";
	    i=i+1; 
	  else 
	    if varargin(i)== "pfeatures",
	      printfv="yes";
	      i=i+1; 
	    end;
	  end;
	end;
      end;
    end;
  end;
 
  // if no polygons through varargin, then default polygons
  if size(Lpoly)==0,
    E=[0,10,10,2,2,7,7,2,2,10,10,0; 0,0,2,2,4,4,6,6,8,8,10,10];
    F=[0,2,2,7,7,2,2,10,10,0; 0,0,4,4,6,6,8,8,10,10]; 
    L=[0,10,10,2,2,0;0,0,2,2,10,10];
    T=[4,6,6,10,10,0,0,4; 0,0,8,8,10,10,8,8];
    Max=[max(E(1,:)),max(F(1,:)),max(L(1,:)),max(T(1,:)); ...
	 max(E(2,:)),max(F(2,:)),max(L(2,:)),max(T(2,:))];
    Min=[min(E(1,:)),min(F(1,:)),min(L(1,:)),min(T(1,:)); ...
	 min(E(2,:)),min(F(2,:)),min(L(2,:)),min(T(2,:))];
    Lpoly=list(E,F,L,T);
  end;
  
  Max=[max(Max(1,:));max(Max(2,:))]; Min=[min(Min(1,:));min(Min(2,:))];
  s=[Min(1),Min(2),Max(1),Max(2)];
  
  n=length(Lpoly);
  setmatrix(f,'size',s);
  set(f,'number',n);
  set(f,'recall',recall);
  set(f,'printfv',printfv);
  set(f,'high_index',hfc);
  set(f,'low_index',lfc);
  
  // storing the reference polygons and their feature vectors
  for k= 1:length(Lpoly),
    Lpol=Lpoly(k);
    pb =polboundary(Lpol);
    pa =polarea(Lpol);
    compl=4*%pi*pa/(pb^2);
    FC =computeFc(hfc,cpolygon(Lpol));
    ds =detect_symmetry(FC);//disp(ds); 
    FD =computeFd(1,ds,FC);
    Fc =polygon(FC);
    Fd =polygon(FD);
    h=hfc;l=lfc;l1=h-l+1;l2=h+l+1;h1=h-l;h2=h+l+2; h3=2*h+1;
    Lvect=[pb;pa;compl; Fc(1,l1:l2)';Fc(2,l1:l2)'; Fc(1,1:h1)'; ...
	   Fc(1,h2:h3)'; Fc(2,1:h1)';Fc(2,h2:h3)';Fd(1,l1:l2)'; ...
	   Fd(2,l1:l2)'; Fd(1,1:h1)'; Fd(1,h2:h3)';Fd(2,1:h1)'; ...
	   Fd(2,h2:h3)'];
    if printfv=='yes',
      disp(Lvect');
    end;
    
   setmatrix(f,string(k)+'vect', Lvect);
   setmatrix(f,string(k)+'pol', Lpol);
  end;
   
  //storing the numbers of the  two graphics-windows  
  wi=new_window();
  set(f,'window1',wi); 
  set(f,'window2',wi+1);
  
endfunction


















