function p = cyclmat(n)
//-----------------------------------------------------------------------  
// function p = cyclmat(n)
//
// implementation of cyclic translation matrix of dimension n.
// Any vector can be translated cyclically by simple multiplication 
// with the transpose of this matrix.
//
// input:    n            dimension of matrix, integer >=1
//
// output:   p            cyclic translation matrix, e.g. n=4 implies
//                        p' * [1 2 3 4]' = [2 3 4 1]'
//
//-----------------------------------------------------------------------  
//   $RCSfile: cyclmat.sci,v $
//  $Revision: 1.1 $
//      $Date: 2002/09/10 15:15:36 $
//  Copyright: IIF-LMB $Author: poluru $
//
//-----------------------------------------------------------------------
//  $Log: 
//-----------------------------------------------------------------------
  
  [out,in] = argn(0);
  
  if in~=1, 
    error('wrong number of input arguments.');
  end;
  
  p = eye(n,n);
  p = [p($,:) ; p(1:$-1,:)];
  
endfunction;




